<template>
  <div class="container">
    <h2>New RelMonsterPath</h2>
    <b-form-input
      v-model="path_id"
      required
      placeholder="path id"
      type="number">
    </b-form-input>
    <small>In case you don't know the path id, visit <nuxt-link to="/admin/paths">paths</nuxt-link></small>
    <b-form-input
      v-model="monster_id"
      required
      placeholder="monster id"
      type="number">
    </b-form-input>
    <small>In case you don't know the monster id, visit <nuxt-link to="/admin/monsters">monsters</nuxt-link></small>
    <b-form-input
      v-model="min_level"
      placeholder="min level"
      type="number">
    </b-form-input>
    <b-form-input
      v-model="max_level"
      placeholder="max level"
      type="number">
    </b-form-input>
    <b-form-input
      v-model="factor"
      placeholder="factor"
      type="number">
    </b-form-input>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      path_id: '',
      monster_id: '',
      min_level: '',
      max_level: '',
      factor: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.path_id * this.monster_id * this.factor * (this.max_level - this.min_level) > 0;
    }
  },
  methods: {
    submit() {
      let data = {
        rel_monster_path: {
          monster_id: this.monster_id,
          path_id: this.path_id,
          factor: this.factor,
          min_level: this.min_level,
          max_level: this.max_level
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/rel_monster_paths',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.path_id = '';
      this.monster_id = '';
      this.min_level = '';
      this.max_level = '';
      this.factor = '';
      this.error = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
